; Undocumented ComboBox
; (masm32)

.386
.model flat,stdcall
option casemap: none

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib comctl32

.const
  STAP_ALLOW_NONCLIENT  equ 1
  STAP_ALLOW_CONTROLS   equ 2
  STAP_ALLOW_WEBCONTENT equ 4
  WM_THEMECHANGED       equ 031Ah
  id                    equ 3000
  idm                   equ SC_SCREENSAVE

.data
  _0     db "Undocumented  "
  _class db "ComboBox",0
  _about db "v.2008-05-15, by kero",0," <geocities.com/xmemor>",0
  _2     db "SendMessage  (WM_SETTEXT)",0
  _20    db "SendMessage  (WM_GETTEXT)",0
  _3     db "SetWindowText",0
  _30    db "GetWindow"
  _1     db "Text",0
  _4     db "OwnProc / DefWindowProc  (WM_SETTEXT)",0    
  _5     db "OwnProc / DefWindowProc  (WM_GETTEXT)",0
  _6     db "OwnProc / DefWindowProc  (WM_PAINT)",0
  _7     db "STAP_ALLOW_NONCLIENT  on/off",0
  _edt   db "EDIT",0
  _btn   db "BUTTON",0
  _UT    db "UxTheme",0
  _ITA   db "IsThemeActive",0
  _STAP  db "SetThemeAppProperties",0
  _GTAP  db "GetThemeAppProperties",0
  _ds    db "(%d)  %s",0
  lf     LOGFONT <-11,0,0,0,400,0,0,0,1,0,0,0,0,"Tahoma">
  count  dd 0
  getset dd 0
  ownproc dd 0
.data?
.code

WinFromPt proc uses ebx
  local pt:POINT
  invoke GetCursorPos,addr pt
  invoke WindowFromPoint,pt.x,pt.y
  mov ebx,eax    
  invoke GetKeyState,VK_CONTROL ; CTRL key
  and eax,8000h
  .if eax!=0 ; root of window beneath cursor
    invoke GetAncestor,ebx,GA_ROOT
  .else ; window beneath cursor
    mov eax,ebx
  .endif
  ret
WinFromPt endp

STAP proc uses ebx hWnd:HWND
  invoke GetModuleHandle,offset _UT
  mov ebx,eax
  .if eax!=0
    invoke GetProcAddress,ebx,offset _ITA
    call eax
    .if eax==TRUE
      invoke GetProcAddress,ebx,offset _GTAP
      call eax
      mov ecx,eax
      or eax,STAP_ALLOW_NONCLIENT  ; STAP_ALLOW_CONTROLS OR STAP_ALLOW_WEBCONTENT OR STAP_ALLOW_NONCLIENT
      .if eax==ecx
        and eax,not STAP_ALLOW_NONCLIENT
      .endif
      push eax
      invoke GetProcAddress,ebx,offset _STAP
      call eax
      invoke SendMessage,hWnd,WM_THEMECHANGED,0,0
    .endif
  .endif
  ret
STAP endp


WndProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local buff[256]:BYTE
  local buf[128]:BYTE
  local pt:POINT
  local rt:RECT
  local ps:PAINTSTRUCT

  .if uMsg==WM_DESTROY
    invoke PostQuitMessage,0

  .elseif uMsg==WM_PAINT
    invoke BeginPaint,hWnd,addr ps
    mov ebx,eax
    invoke GetClientRect,hWnd,addr rt
    invoke GetStockObject,WHITE_BRUSH
    invoke FillRect,ebx,addr rt,eax
    invoke EndPaint,hWnd,addr ps
    xor eax,eax

  .elseif uMsg==WM_CTLCOLOREDIT
    invoke GetStockObject,WHITE_BRUSH

  .elseif uMsg==WM_COMMAND
    mov eax,wParam
    .if eax==id+2 || eax==id+3    
      invoke WinFromPt
      mov ebx,eax      
      .if getset!=0  ; GetText
        .if wParam==id+2
          invoke SendMessageTimeout,ebx,WM_GETTEXT,255,addr buff,SMTO_ABORTIFHUNG,300,0
        .else
          invoke GetWindowText,ebx,addr buff,255
        .endif
        invoke SendDlgItemMessage,hWnd,id+1,WM_SETTEXT,0,addr buff
      .else  ; SetText
        .if ebx==lParam
          mov ebx,hWnd
        .endif
        invoke SendDlgItemMessage,hWnd,id+1,WM_GETTEXT,127,addr buf
        mov ecx,count
        inc count
        invoke wsprintf,addr buff,offset _ds,ecx,addr buf
        .if wParam==id+2
          invoke SendMessageTimeout,ebx,WM_SETTEXT,0,addr buff,SMTO_ABORTIFHUNG,300,0
        .else
          invoke SetWindowText,ebx,addr buff
        .endif
      .endif      
    .elseif eax==id+6
      invoke STAP,hWnd
      mov ebx,hWnd
    .elseif eax==id+4 || eax==id+5 || eax==040003E9h || eax==030003E9h  ; (EN_UPDATE/EN_CHANGE, wID:1001)
      mov ebx,hWnd
    .endif
    invoke SetWindowPos,ebx,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE
    xor eax,eax

;  .elseif uMsg==WM_KEYDOWN || uMsg==WM_KEYUP || uMsg==WM_CHAR || uMsg==WM_PASTE || uMsg==WM_CUT || uMsg==WM_CLEAR || uMsg==WM_UNDO
;    invoke CallWindowProc,ownproc,hWnd,uMsg,wParam,lParam
;    invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE

  .elseif uMsg==WM_CONTEXTMENU
    invoke GetWindowLong,wParam,GWL_ID
    .if eax==id+2 || eax==id+3
      xor getset,1
      .if getset!=0
        mov ecx,offset _20
        mov ebx,offset _30
      .else
        mov ecx,offset _2
        mov ebx,offset _3
      .endif
      invoke SendDlgItemMessage,hWnd,id+2,WM_SETTEXT,0,ecx
      invoke SendDlgItemMessage,hWnd,id+3,WM_SETTEXT,0,ebx
    .endif
    jmp @dwp

  .elseif uMsg==WM_SETTEXT
    mov eax,id+4
    jmp @f
  .elseif uMsg==WM_GETTEXT
    mov eax,id+5
@@:
    invoke SendDlgItemMessage,hWnd,eax,BM_GETCHECK,0,0
    .if eax!=BST_CHECKED
@dwp:
      invoke DefWindowProc,hWnd,uMsg,wParam,lParam
    .else
      jmp @cwp
    .endif

  .else
@cwp:
    invoke CallWindowProc,ownproc,hWnd,uMsg,wParam,lParam
  .endif
  ret
WndProc endp

WinMain proc uses ebx edi hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
  local msg:MSG
  local hfont:HFONT
  invoke CreateWindowEx,WS_EX_TOPMOST,offset _class,offset _0,WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN,20,20,300,240,0,0,hInst,0
  mov ebx,eax
  push ebx
  invoke SetWindowLong,ebx,GWL_WNDPROC,offset WndProc
  mov ownproc,eax
  invoke GetWindowLong,ebx,GWL_STYLE
  or eax,WS_BORDER
;  and eax,not CBS_HASSTRINGS
  invoke SetWindowLong,ebx,GWL_STYLE,eax
  invoke GetClassLong,ebx,GCL_STYLE
  and eax,not (CS_VREDRAW or CS_PARENTDC or CS_HREDRAW)
  invoke SetClassLong,ebx,GCL_STYLE,eax
  invoke SetWindowPos,ebx,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE
  invoke GetWindow,ebx,GW_CHILD
  invoke ShowWindow,eax,SW_HIDE
  mov edi,eax
  invoke SetWindowPos,eax,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_FRAMECHANGED OR SWP_NOACTIVATE
  
  invoke CreateWindowEx,0,offset _edt,offset _0,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP OR ES_AUTOHSCROLL OR WS_BORDER,20,30,250,22,ebx,id+1,hInst,0  ; (test WS_BORDER !)
  push eax
;  invoke SetFocus,eax
  invoke CreateWindowEx,0,offset _btn,offset _2,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP,20,56,250,23,ebx,id+2,hInst,0
  push eax
  invoke CreateWindowEx,0,offset _btn,offset _3,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP,20,81,250,23,ebx,id+3,hInst,0
  push eax
  invoke CreateWindowEx,0,offset _btn,offset _4,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP OR BS_AUTOCHECKBOX,20,108,250,20,ebx,id+4,hInst,0
  push eax
  invoke SendMessage,eax,BM_SETCHECK,BST_CHECKED,0
  invoke CreateWindowEx,0,offset _btn,offset _5,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP OR BS_AUTOCHECKBOX,20,128,250,20,ebx,id+5,hInst,0
  push eax
  invoke SendMessage,eax,BM_SETCHECK,BST_CHECKED,0
  invoke CreateWindowEx,0,offset _btn,offset _7,WS_CHILD OR WS_VISIBLE OR WS_TABSTOP,20,152,250,23,ebx,id+6,hInst,0
  push eax    
  xor edi,edi
  invoke CreateFontIndirect,offset lf
  mov hfont,eax
  .while edi<=6
    pop ecx
    invoke SendMessage,ecx,WM_SETFONT,hfont,0
    inc edi
  .endw
  invoke GetSystemMenu,ebx,0
  mov edi,eax
  invoke AppendMenu,edi,MF_SEPARATOR,0,0
  invoke AppendMenu,edi,MF_STRING,idm,offset _about
  invoke ShowWindow,ebx,CmdShow
  invoke UpdateWindow,ebx
  .while TRUE
    invoke GetMessage,addr msg,0,0,0
    .break .if (!eax)
    invoke IsDialogMessage,ebx,addr msg
    .if eax==FALSE
      invoke TranslateMessage,addr msg
      invoke DispatchMessage,addr msg
    .endif
  .endw
  invoke DeleteObject,hfont
  mov	eax,msg.wParam
  ret
WinMain endp

start:
  invoke GetModuleHandle,0
  invoke WinMain,eax,0,0,SW_SHOWDEFAULT
  invoke ExitProcess,eax
  invoke InitCommonControls
end start
